
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【转载】对一致性Hash算法，Java代码实现的深入研究 / iVAN</title>

    <meta name="description" content="【转载】对一致性Hash算法，Java代码实现的深入研究 原文地址:http://www.cnblogs.com/xrq730/p/5186728.html   一致性Hash算法 关于一致性Hash算法,在我之前的博文中已经有多次提到了,MemCache超详细解读一文中&quot;一致性Hash算法&quot;部分,对于为什么要使用一致性Hash算法.一致性Hash算法的算法原理做了详细的解读. 算法的具体原理这里再次贴上: 先构造一个长度为232的整数环(这个环被称为一致性Hash环),根据节点名称的Hash值(其分布为[0, 232-1])将服务 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">【转载】对一致性Hash算法，Java代码实现的深入研究</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文地址：http://www.cnblogs.com/xrq730/p/5186728.html</p>
<p> </p>
<p><strong>一致性Hash算法</strong></p>
<p>关于一致性Hash算法，在我之前的博文中已经有多次提到了，<a href="http://www.cnblogs.com/xrq730/p/4948707.html" rel="external nofollow noreferrer">MemCache超详细解读</a>一文中"一致性Hash算法"部分，对于为什么要使用一致性Hash算法、一致性Hash算法的算法原理做了详细的解读。</p>
<p>算法的具体原理这里再次贴上：</p>
<p><strong>先构造一个长度为2<sup>32</sup>的整数环（这个环被称为一致性Hash环），根据节点名称的Hash值（其分布为[0, 2<sup>32</sup>-1]）将服务器节点放置在这个Hash环上，然后根据数据的Key值计算得到其Hash值（其分布也为[0, 2<sup>32</sup>-1]），接着在Hash环上顺时针查找距离这个Key值的Hash值最近的服务器节点，完成Key到服务器的映射查找。</strong></p>
<p>这种算法解决了普通余数Hash算法伸缩性差的问题，可以保证在上线、下线服务器的情况下尽量有多的请求命中原来路由到的服务器。</p>
<p>当然，万事不可能十全十美，一致性Hash算法比普通的余数Hash算法更具有伸缩性，但是同时其算法实现也更为复杂，本文就来研究一下，如何利用Java代码实现一致性Hash算法。在开始之前，先对一致性Hash算法中的几个核心问题进行一些探究。</p>
<p> </p>
<p><strong>数据结构的选取</strong></p>
<p>一致性Hash算法最先要考虑的一个问题是：构造出一个长度为2<sup>32</sup>的整数环，根据节点名称的Hash值将服务器节点放置在这个Hash环上。</p>
<p>那么，整数环应该使用何种数据结构，才能使得运行时的时间复杂度最低？首先说明一点，关于时间复杂度，常见的时间复杂度与时间效率的关系有如下的经验规则：</p>
<p><strong>O(1) &lt; O(log<sub>2</sub>N) &lt; O(n) &lt; O(N * log<sub>2</sub>N) &lt; O(N<sup>2</sup>) &lt; O(N<sup>3</sup>) &lt; 2N &lt; 3N &lt; N!</strong></p>
<p>一般来说，前四个效率比较高，中间两个差强人意，后三个比较差（只要N比较大，这个算法就动不了了）。OK，继续前面的话题，应该如何选取数据结构，我认为有以下几种可行的解决方案。</p>
<p><strong>1、解决方案一：排序+List</strong></p>
<p>我想到的第一种思路是：算出所有待加入数据结构的节点名称的Hash值放入一个数组中，然后使用某种排序算法将其从小到大进行排序，最后将排序后的数据放入List中，采用List而不是数组是为了结点的扩展考虑。</p>
<p><strong>之后，待路由的结点，只需要在List中找到第一个Hash值比它大的服务器节点就可以了</strong>，比如服务器节点的Hash值是[0,2,4,6,8,10]，带路由的结点是7，只需要找到第一个比7大的整数，也就是8，就是我们最终需要路由过去的服务器节点。</p>
<p>如果暂时不考虑前面的排序，那么这种解决方案的时间复杂度：</p>
<p>（1）最好的情况是第一次就找到，时间复杂度为O(1)</p>
<p>（2）最坏的情况是最后一次才找到，时间复杂度为O(N)</p>
<p>平均下来时间复杂度为O(0.5N+0.5)，忽略首项系数和常数，时间复杂度为O(N)。</p>
<p>但是如果考虑到之前的排序，我在网上找了张图，提供了各种排序算法的时间复杂度：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iODdhOTZhNjgyMzY1OWM3NTU1YzIxYzA3NzQwOWJjOC5qcGc=.jpg"></p>
<p>看得出来，排序算法要么稳定但是时间复杂度高、要么时间复杂度低但不稳定，看起来最好的归并排序法的时间复杂度仍然有O(N * logN)，稍微耗费性能了一些。</p>
<p><strong>2、解决方案二：遍历+List</strong></p>
<p>既然排序操作比较耗性能，那么能不能不排序？可以的，所以进一步的，有了第二种解决方案。</p>
<p>解决方案使用List不变，不过可以采用遍历的方式：</p>
<p>（1）服务器节点不排序，其Hash值全部直接放入一个List中</p>
<p>（2）带路由的节点，算出其Hash值，由于指明了"顺时针"，因此遍历List，比待路由的节点Hash值大的算出差值并记录，比待路由节点Hash值小的忽略</p>
<p>（3）算出所有的差值之后，最小的那个，就是最终需要路由过去的节点</p>
<p>在这个算法中，看一下时间复杂度：</p>
<p>1、最好情况是只有一个服务器节点的Hash值大于带路由结点的Hash值，其时间复杂度是O(N)+O(1)=O(N+1)，忽略常数项，即O(N)</p>
<p>2、最坏情况是所有服务器节点的Hash值都大于带路由结点的Hash值，其时间复杂度是O(N)+O(N)=O(2N)，忽略首项系数，即O(N)</p>
<p>所以，总的时间复杂度就是O(N)。其实算法还能更改进一些：给一个位置变量X，如果新的差值比原差值小，X替换为新的位置，否则X不变。这样遍历就减少了一轮，不过经过改进后的算法时间复杂度仍为O(N)。</p>
<p>总而言之，这个解决方案和解决方案一相比，总体来看，似乎更好了一些。</p>
<p><strong>3、解决方案三：二叉查找树</strong></p>
<p>抛开List这种数据结构，另一种数据结构则是使用<strong>二叉查找树</strong>。对于树不是很清楚的朋友可以简单看一下这篇文章<a href="http://www.cnblogs.com/xrq730/p/5187032.html" rel="external nofollow noreferrer">树形结构</a>。</p>
<p>当然我们不能简单地使用二叉查找树，因为可能出现不平衡的情况。平衡二叉查找树有AVL树、红黑树等，这里使用红黑树，选用红黑树的原因有两点：</p>
<p>1、红黑树主要的作用是用于存储有序的数据，这其实和第一种解决方案的思路又不谋而合了，但是它的效率非常高</p>
<p>2、JDK里面提供了红黑树的代码实现TreeMap和TreeSet</p>
<p>另外，以TreeMap为例，TreeMap本身提供了一个tailMap(K fromKey)方法，支持从红黑树中查找比fromKey大的值的集合，但并不需要遍历整个数据结构。</p>
<p>使用红黑树，可以使得查找的时间复杂度降低为O(logN)，比上面两种解决方案，效率大大提升。</p>
<p>为了验证这个说法，我做了一次测试，从大量数据中查找第一个大于其中间值的那个数据，比如10000数据就找第一个大于5000的数据（模拟平均的情况）。看一下O(N)时间复杂度和O(logN)时间复杂度运行效率的对比：</p>
<table>
<tbody>
<tr>
<td> </td>
<td><strong>50000</strong></td>
<td><strong>100000</strong></td>
<td><strong>500000</strong></td>
<td><strong>1000000</strong></td>
<td><strong>4000000</strong></td>
</tr>
<tr>
<td><strong>ArrayList</strong></td>
<td><strong>1ms</strong></td>
<td><strong>1ms</strong></td>
<td><strong>4ms</strong></td>
<td><strong>4ms</strong></td>
<td><strong>5ms</strong></td>
</tr>
<tr>
<td><strong>LinkedList</strong></td>
<td><strong>4ms</strong></td>
<td><strong>7ms</strong></td>
<td><strong>11ms</strong></td>
<td><strong>13ms</strong></td>
<td><strong>17ms</strong></td>
</tr>
<tr>
<td><strong>TreeMap</strong></td>
<td><strong>0ms</strong></td>
<td><strong>0ms</strong></td>
<td><strong>0ms</strong></td>
<td><strong>0ms</strong></td>
<td><strong>0ms</strong></td>
</tr>
</tbody>
</table>
<p>因为再大就内存溢出了，所以只测试到4000000数据。可以看到，数据查找的效率，TreeMap是完胜的，其实再增大数据测试也是一样的，红黑树的数据结构决定了任何一个大于N的最小数据，它都只需要几次至几十次查找就可以查到。</p>
<p>当然，明确一点，有利必有弊，根据我另外一次测试得到的结论是，<strong>为了维护红黑树，数据插入效率TreeMap在三种数据结构里面是最差的，且插入要慢上5~10倍</strong>。</p>
<p> </p>
<p><strong>Hash值重新计算</strong></p>
<p>服务器节点我们肯定用字符串来表示，比如"192.168.1.1"、"192.168.1.2"，根据字符串得到其Hash值，那么另外一个重要的问题就是Hash值要重新计算，这个问题是我在测试String的hashCode()方法的时候发现的，不妨来看一下为什么要重新计算Hash值：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>/**
 * String的hashCode()方法运算结果查看
 * @author 五月的仓颉 http://www.cnblogs.com/xrq730/
 *
 */
public class StringHashCodeTest
{
    public static void main(String[] args)
    {
        System.out.println("192.168.0.0:111的哈希值：" + "192.168.0.0:1111".hashCode());
        System.out.println("192.168.0.1:111的哈希值：" + "192.168.0.1:1111".hashCode());
        System.out.println("192.168.0.2:111的哈希值：" + "192.168.0.2:1111".hashCode());
        System.out.println("192.168.0.3:111的哈希值：" + "192.168.0.3:1111".hashCode());
        System.out.println("192.168.0.4:111的哈希值：" + "192.168.0.4:1111".hashCode());
    }
}</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>我们在做集群的时候，集群点的IP以这种连续的形式存在是很正常的。看一下运行结果为：</p>
<pre>192.168.0.0:111的哈希值：1845870087
192.168.0.1:111的哈希值：1874499238
192.168.0.2:111的哈希值：1903128389
192.168.0.3:111的哈希值：1931757540
192.168.0.4:111的哈希值：1960386691</pre>
<p>这个就问题大了，[0,2<sup>32</sup>-1]的区间之中，5个HashCode值却只分布在这么小小的一个区间，什么概念？[0,2<sup>32</sup>-1]中有4294967296个数字，而我们的区间只有114516604，从概率学上讲这将导致97%待路由的服务器都被路由到"192.168.0.0"这个集群点上，简直是糟糕透了！</p>
<p>另外还有一个不好的地方：规定的区间是非负数，String的hashCode()方法却会产生负数（不信用"192.168.1.0:1111"试试看就知道了）。不过这个问题好解决，取绝对值就是一种解决的办法。</p>
<p>综上，String重写的hashCode()方法在一致性Hash算法中没有任 何实用价值，得找个算法重新计算HashCode。这种重新计算Hash值的算法有很多，比如CRC32_HASH、FNV1_32_HASH、 KETAMA_HASH等，其中KETAMA_HASH是默认的MemCache推荐的一致性Hash算法，用别的Hash算法也可以，比如 FNV1_32_HASH算法的计算效率就会高一些。</p>
<p> </p>
<p><strong>一致性Hash算法实现版本1：不带虚拟节点</strong></p>
<p>使用一致性Hash算法，尽管增强了系统的伸缩性，但是也有可能导致负载分布不均匀，解决办法就是使用<strong>虚拟节点代替真实节点</strong>，第一个代码版本，先来个简单的，不带虚拟节点。</p>
<p>下面来看一下不带虚拟节点的一致性Hash算法的Java代码实现：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre> 1 /**
 2  * 不带虚拟节点的一致性Hash算法
 3  * @author 五月的仓颉http://www.cnblogs.com/xrq730/
 4  *
 5  */
 6 public class ConsistentHashingWithoutVirtualNode
 7 {
 8     /**
 9      * 待添加入Hash环的服务器列表
10      */
11     private static String[] servers = {"192.168.0.0:111", "192.168.0.1:111", "192.168.0.2:111",
12             "192.168.0.3:111", "192.168.0.4:111"};
13
14     /**
15      * key表示服务器的hash值，value表示服务器的名称
16      */
17     private static SortedMap&lt;Integer, String&gt; sortedMap =
18             new TreeMap&lt;Integer, String&gt;();
19
20     /**
21      * 程序初始化，将所有的服务器放入sortedMap中
22      */
23     static
24     {
25         for (int i = 0; i &lt; servers.length; i++)
26         {
27             int hash = getHash(servers[i]);
28             System.out.println("[" + servers[i] + "]加入集合中, 其Hash值为" + hash);
29             sortedMap.put(hash, servers[i]);
30         }
31         System.out.println();
32     }
33
34     /**
35      * 使用FNV1_32_HASH算法计算服务器的Hash值,这里不使用重写hashCode的方法，最终效果没区别
36      */
37     private static int getHash(String str)
38     {
39         final int p = 16777619;
40         int hash = (int)2166136261L;
41         for (int i = 0; i &lt; str.length(); i++)
42             hash = (hash ^ str.charAt(i)) * p;
43         hash += hash &lt;&lt; 13;
44         hash ^= hash &gt;&gt; 7;
45         hash += hash &lt;&lt; 3;
46         hash ^= hash &gt;&gt; 17;
47         hash += hash &lt;&lt; 5;
48
49         // 如果算出来的值为负数则取其绝对值
50         if (hash &lt; 0)
51             hash = Math.abs(hash);
52         return hash;
53     }
54
55     /**
56      * 得到应当路由到的结点
57      */
58     private static String getServer(String node)
59     {
60         // 得到带路由的结点的Hash值
61         int hash = getHash(node);
62         // 得到大于该Hash值的所有Map
63         SortedMap&lt;Integer, String&gt; subMap =
64                 sortedMap.tailMap(hash);
65         // 第一个Key就是顺时针过去离node最近的那个结点
66         Integer i = subMap.firstKey();
67         // 返回对应的服务器名称
68         return subMap.get(i);
69     }
70
71     public static void main(String[] args)
72     {
73         String[] nodes = {"127.0.0.1:1111", "221.226.0.1:2222", "10.211.0.1:3333"};
74         for (int i = 0; i &lt; nodes.length; i++)
75             System.out.println("[" + nodes[i] + "]的hash值为" +
76                     getHash(nodes[i]) + ", 被路由到结点[" + getServer(nodes[i]) + "]");
77     }
78 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>可以运行一下看一下结果：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>[192.168.0.0:111]加入集合中, 其Hash值为575774686
[192.168.0.1:111]加入集合中, 其Hash值为8518713
[192.168.0.2:111]加入集合中, 其Hash值为1361847097
[192.168.0.3:111]加入集合中, 其Hash值为1171828661
[192.168.0.4:111]加入集合中, 其Hash值为1764547046

[127.0.0.1:1111]的hash值为380278925, 被路由到结点[192.168.0.0:111]
[221.226.0.1:2222]的hash值为1493545632, 被路由到结点[192.168.0.4:111]
[10.211.0.1:3333]的hash值为1393836017, 被路由到结点[192.168.0.4:111]</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>看到经过FNV1_32_HASH算法重新计算过后的Hash值，就比原来String的hashCode()方法好多了。从运行结果来看，也没有问题，三个点路由到的都是顺时针离他们Hash值最近的那台服务器上。</p>
<p> </p>
<p><strong>使用虚拟节点来改善一致性Hash算法</strong></p>
<p>上面的一致性Hash算法实现，可以在很大程度上解决很多分布式环境下不好的路由算法导致系统伸缩性差的问题，但是会带来另外一个问题：负载不均。</p>
<p>比如说有Hash环上有A、B、C三个服务器节点，分别有100个请求会被路由到相应服务器上。现在在A与B之间增加了一个节点D，这导致了原来会路由到B上的部分节点被路由到了D上，这样A、C上被路由到的请求明显多于B、D上的，原来三个服务器节点上均衡的负载被打破了。<strong>某种程度上来说，这失去了负载均衡的意义，因为负载均衡的目的本身就是为了使得目标服务器均分所有的请求</strong>。</p>
<p>解决这个问题的办法是引入虚拟节点，其工作原理是：<strong>将一个物理节点拆分为多个虚拟节点，并且同一个物理节点的虚拟节点尽量均匀分布在Hash环上</strong>。采取这样的方式，就可以有效地解决增加或减少节点时候的负载不均衡的问题。</p>
<p>至于一个物理节点应该拆分为多少虚拟节点，下面可以先看一张图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xODM5OTI5YzlmZmU2NmM0YmNkY2ExMjk1Mzg0NGQ4ZS5wbmc=.jpg"></p>
<p>横轴表示需要为每台福利服务器扩展的虚拟节点倍数，纵轴表示的是实际物理服务器数。可以看出，物理服务器很少，需要更大的虚拟节点；反之物理服务器比较多，虚拟节点就可以少一些。比如有10台物理服务器，那么差不多需要为每台服务器增加100~200个虚拟节点才可以达到真正的负载均衡。</p>
<p> </p>
<p><strong>一致性Hash算法实现版本2：带虚拟节点</strong></p>
<p>在理解了使用虚拟节点来改善一致性Hash算法的理论基础之后，就可以尝试开发代码了。编程方面需要考虑的问题是：</p>
<p>1、一个真实结点如何对应成为多个虚拟节点？</p>
<p>2、虚拟节点找到后如何还原为真实结点？</p>
<p>这两个问题其实有很多解决办法，我这里使用了一种简单的办法，给每个真实结点后面根据虚拟节点加上后缀再取Hash值，比如"192.168.0.0:111"就把它变成"192.168.0.0:111&amp;&amp;VN0"到"192.168.0.0:111&amp;&amp;VN4"，VN就是Virtual Node的缩写，还原的时候只需要从头截取字符串到"&amp;&amp;"的位置就可以了。</p>
<p>下面来看一下带虚拟节点的一致性Hash算法的Java代码实现：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre> 1 /**
 2  * 带虚拟节点的一致性Hash算法
 3  * @author 五月的仓颉 http://www.cnblogs.com/xrq730/
 4  */
 5 public class ConsistentHashingWithVirtualNode
 6 {
 7     /**
 8      * 待添加入Hash环的服务器列表
 9      */
10     private static String[] servers = {"192.168.0.0:111", "192.168.0.1:111", "192.168.0.2:111",
11             "192.168.0.3:111", "192.168.0.4:111"};
12
13     /**
14      * 真实结点列表,考虑到服务器上线、下线的场景，即添加、删除的场景会比较频繁，这里使用LinkedList会更好
15      */
16     private static List&lt;String&gt; realNodes = new LinkedList&lt;String&gt;();
17
18     /**
19      * 虚拟节点，key表示虚拟节点的hash值，value表示虚拟节点的名称
20      */
21     private static SortedMap&lt;Integer, String&gt; virtualNodes =
22             new TreeMap&lt;Integer, String&gt;();
23
24     /**
25      * 虚拟节点的数目，这里写死，为了演示需要，一个真实结点对应5个虚拟节点
26      */
27     private static final int VIRTUAL_NODES = 5;
28
29     static
30     {
31         // 先把原始的服务器添加到真实结点列表中
32         for (int i = 0; i &lt; servers.length; i++)
33             realNodes.add(servers[i]);
34
35         // 再添加虚拟节点，遍历LinkedList使用foreach循环效率会比较高
36         for (String str : realNodes)
37         {
38             for (int i = 0; i &lt; VIRTUAL_NODES; i++)
39             {
40                 String virtualNodeName = str + "&amp;&amp;VN" + String.valueOf(i);
41                 int hash = getHash(virtualNodeName);
42                 System.out.println("虚拟节点[" + virtualNodeName + "]被添加, hash值为" + hash);
43                 virtualNodes.put(hash, virtualNodeName);
44             }
45         }
46         System.out.println();
47     }
48
49     /**
50      * 使用FNV1_32_HASH算法计算服务器的Hash值,这里不使用重写hashCode的方法，最终效果没区别
51      */
52     private static int getHash(String str)
53     {
54         final int p = 16777619;
55         int hash = (int)2166136261L;
56         for (int i = 0; i &lt; str.length(); i++)
57             hash = (hash ^ str.charAt(i)) * p;
58         hash += hash &lt;&lt; 13;
59         hash ^= hash &gt;&gt; 7;
60         hash += hash &lt;&lt; 3;
61         hash ^= hash &gt;&gt; 17;
62         hash += hash &lt;&lt; 5;
63
64         // 如果算出来的值为负数则取其绝对值
65         if (hash &lt; 0)
66             hash = Math.abs(hash);
67         return hash;
68     }
69
70     /**
71      * 得到应当路由到的结点
72      */
73     private static String getServer(String node)
74     {
75         // 得到带路由的结点的Hash值
76         int hash = getHash(node);
77         // 得到大于该Hash值的所有Map
78         SortedMap&lt;Integer, String&gt; subMap =
79                 virtualNodes.tailMap(hash);
80         // 第一个Key就是顺时针过去离node最近的那个结点
81         Integer i = subMap.firstKey();
82         // 返回对应的虚拟节点名称，这里字符串稍微截取一下
83         String virtualNode = subMap.get(i);
84         return virtualNode.substring(0, virtualNode.indexOf("&amp;&amp;"));
85     }
86
87     public static void main(String[] args)
88     {
89         String[] nodes = {"127.0.0.1:1111", "221.226.0.1:2222", "10.211.0.1:3333"};
90         for (int i = 0; i &lt; nodes.length; i++)
91             System.out.println("[" + nodes[i] + "]的hash值为" +
92                     getHash(nodes[i]) + ", 被路由到结点[" + getServer(nodes[i]) + "]");
93     }
94 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>关注一下运行结果：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>虚拟节点[192.168.0.0:111&amp;&amp;VN0]被添加, hash值为1686427075
虚拟节点[192.168.0.0:111&amp;&amp;VN1]被添加, hash值为354859081
虚拟节点[192.168.0.0:111&amp;&amp;VN2]被添加, hash值为1306497370
虚拟节点[192.168.0.0:111&amp;&amp;VN3]被添加, hash值为817889914
虚拟节点[192.168.0.0:111&amp;&amp;VN4]被添加, hash值为396663629
虚拟节点[192.168.0.1:111&amp;&amp;VN0]被添加, hash值为1032739288
虚拟节点[192.168.0.1:111&amp;&amp;VN1]被添加, hash值为707592309
虚拟节点[192.168.0.1:111&amp;&amp;VN2]被添加, hash值为302114528
虚拟节点[192.168.0.1:111&amp;&amp;VN3]被添加, hash值为36526861
虚拟节点[192.168.0.1:111&amp;&amp;VN4]被添加, hash值为848442551
虚拟节点[192.168.0.2:111&amp;&amp;VN0]被添加, hash值为1452694222
虚拟节点[192.168.0.2:111&amp;&amp;VN1]被添加, hash值为2023612840
虚拟节点[192.168.0.2:111&amp;&amp;VN2]被添加, hash值为697907480
虚拟节点[192.168.0.2:111&amp;&amp;VN3]被添加, hash值为790847074
虚拟节点[192.168.0.2:111&amp;&amp;VN4]被添加, hash值为2010506136
虚拟节点[192.168.0.3:111&amp;&amp;VN0]被添加, hash值为891084251
虚拟节点[192.168.0.3:111&amp;&amp;VN1]被添加, hash值为1725031739
虚拟节点[192.168.0.3:111&amp;&amp;VN2]被添加, hash值为1127720370
虚拟节点[192.168.0.3:111&amp;&amp;VN3]被添加, hash值为676720500
虚拟节点[192.168.0.3:111&amp;&amp;VN4]被添加, hash值为2050578780
虚拟节点[192.168.0.4:111&amp;&amp;VN0]被添加, hash值为586921010
虚拟节点[192.168.0.4:111&amp;&amp;VN1]被添加, hash值为184078390
虚拟节点[192.168.0.4:111&amp;&amp;VN2]被添加, hash值为1331645117
虚拟节点[192.168.0.4:111&amp;&amp;VN3]被添加, hash值为918790803
虚拟节点[192.168.0.4:111&amp;&amp;VN4]被添加, hash值为1232193678

[127.0.0.1:1111]的hash值为380278925, 被路由到结点[192.168.0.0:111]
[221.226.0.1:2222]的hash值为1493545632, 被路由到结点[192.168.0.0:111]
[10.211.0.1:3333]的hash值为1393836017, 被路由到结点[192.168.0.2:111]</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>从代码运行结果看，每个点路由到的服务器都是Hash值顺时针离它最近的那个服务器节点，没有任何问题。</p>
<p>通过采取虚拟节点的方法，一个真实结点不再固定在Hash换上的某个点，而是大量地分布在整个Hash环上，这样即使上线、下线服务器，也不会造成整体的负载不均衡。</p>
<p> </p>
<p><strong>后记</strong></p>
<p>在写本文的时候，很多知识我也是边写边学，难免有很多写得不好、理解得不透彻的地方，而且代码整体也比较糙，未有考虑到可能的各种情况。抛砖引玉，一方面，写得不对的地方，还望网友朋友们指正；另一方面，后续我也将通过自己的工作、学习不断完善上面的代码。</p>
<p><strong>==================================================================================</p>
<p>我不能保证写的每个地方都是对的，但是至少能保证不复制、不黏贴，保证每一句话、每一行代码都经过了认真的推敲、仔细的斟酌。每一篇文章的背后，希望都能看到自己对于技术、对于生活的态度。</p>
<p>我相信乔布斯说的，只有那些疯狂到认为自己可以改变世界的人才能真正地改变世界。面对压力，我可以挑灯夜战、不眠不休；面对困难，我愿意迎难而上、永不退缩。</p>
<p><strong>其实我想说的是，我只是一个程序员，这就是我现在纯粹人生的全部。</p>
<p>==================================================================================</strong></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 18:32:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e8%a7%a3%e5%86%b3%e6%96%b9%e6%a1%88/" title="解决方案">解决方案</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/hash/" title="hash">hash</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>【转载】对一致性Hash算法，Java代码实现的深入研究的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVmGJBp.html" rel="bookmark">【策略】一致性Hash算法（Hash环）的java代码实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[一]一致性hash算法,基本实现分布平衡. 1 package org.ehking.quartz.curator; 2 3 import java.util.SortedMap; 4 import java.util.TreeMap; 5 6 public class ConsistentHashingWithoutVirtualNode { 7 /** 8 * 待添加入Hash环的服务器列表 9 */ 10 private static String[] servers = {&quot;192.1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnK2ROz.html" rel="bookmark">Java实现一致性Hash算法深入研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一致性Hash算法 关于一致性Hash算法,在我之前的博文中已经有多次提到了,MemCache超详细解读一文中&quot;一致性Hash算法&quot;部分,对于为什么要使用一致性Hash算法和一致性Hash算法的算法原理做了详细的解读. 算法的具体原理这里再次贴上: 先构造一个长度为2 32 的整数环(这个环被称为一致性Hash环),根据节点名称的Hash值(其分布为[0, 2 32 -1])将服务器节点放置在这个Hash环上,然后根据数据的Key值计算得到其Hash值(其分布也为[0, 2 32 -1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3nxEz.html" rel="bookmark">5分钟理解一致性 hash 算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请说明出处:http://blog.csdn.net/cywosp/article/details/23397179     一致性哈希算法在1997年由麻省理工学院提出的一种分布式哈希(DHT)实现算法,设计目标是为了解决因特网中的热点(Hot spot)问题,初衷和CARP十分类似.一致性哈希修正了CARP使用的简 单哈希算法带来的问题,使得分布式哈希(DHT)可以在P2P环境中真正得到应用.        一致性hash算法提出了在动态变化的Cache环境中,判定哈希算法好坏的四个定义			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN72q7p.html" rel="bookmark">一致性Hash算法&lpar;分布式哈希&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一致性哈希算法在1997年由麻省理工学院提出的一种分布式哈希(DHT)实现算法,设计目标是为了解决因特网中的热点(Hot spot)问题,初衷和CARP十分类似.一致性哈希修正了CARP使用的简单哈希算法带来的问题,使得分布式哈希(DHT)可以在P2P环境中真正得到应用.      一致性hash算法提出了在动态变化的Cache环境中,判定哈希算法好坏的四个定义: 1.平衡性(Balance):平衡性是指哈希的结果能够尽可能分布到所有的缓冲中去,这样可以使得所有的缓冲空间都得到利用.很多哈希算法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrdx31z.html" rel="bookmark">基于一致性hash算法 C&plus;&plus;语言的实现详解&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    一致性hash算法实现有两个关键问题需要解决,一个是用于结点存储和查找的数据结构的选择,另一个是结点hash算法的选择.     首先来谈一下一致性hash算法中用于存储结点的数据结构.通过了解一致性hash的原理,我们知道结点可以想象为是存储在一个环形的数据结构上(如下图),结点A.B.C.D按hash值在环形分布上是有序的,也就是说结点可以按hash值存储在一个有序的队列里.如下图所示,当一个hash值为-2^20的请求点P查找路由结点时,一致性hash算法会按hash值的顺时针方向			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmjY15z.html" rel="bookmark">【策略】一致性Hash算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请说明出处:http://blog.csdn.net/cywosp/article/details/23397179     一致性哈希算法在1997年由麻省理工学院提出的一种分布式哈希(DHT)实现算法,设计目标是为了解决因特网中的热点(Hot spot)问题,初衷和CARP十分类似.一致性哈希修正了CARP使用的简 单哈希算法带来的问题,使得分布式哈希(DHT)可以在P2P环境中真正得到应用.      一致性hash算法提出了在动态变化的Cache环境中,判定哈希算法好坏的四个定义:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7O5xp.html" rel="bookmark">一致性 hash 算法（consistent hashing）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一致性 hash 算法(consistent hashing)  consistent hashing 算法早在 1997 年就在论文 Consistent hashing and random trees 中被提出,目前在 cache 系统中应用越来越广泛: 1 基本场景 比如你有 N 个 cache 服务器(后面简称 cache ),那么如何将一个对象 object 映射到 N 个 cache 上呢,你很可能会采用类似下面的通用方法计算 object 的 hash 值,然后均匀的映射到到 N			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvWBJ9p.html" rel="bookmark">一致性hash算法与server列表维护</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  考虑到不用重复造轮子,特此转载好文,出处http://shift-alt-ctrl.iteye.com/blog/1963244     普通的hash算法有个很大的问题:当hash的&quot;模数&quot;发生变化时,整个hash数据结构就需要重新hash,重新hash之后的数据分布一定会和hash之前的不同;在很多场景下,&quot;模数&quot;的变化时必然的,但是这种&quot;数据分布&quot;的巨大变化却会带来一些麻烦.所以,就有了&quot;一致性hash&quot;,当然学术界			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqVVYZp.html" rel="bookmark">一致性 hash 算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				consistent hashing 算法早在 1997 年就在论文 Consistent hashing and random trees 中被提出,目前在 cache 系统中应用越来越广泛: 1 基本场景 比如你有 N 个 cache 服务器(后面简称 cache ),那么如何将一个对象 object 映射到 N 个 cache 上呢,你很可能会采用类似下面的通用方法计算 object 的 hash 值,然后均匀的映射到到 N 个 cache : hash(object)%N 一切都运行正常			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgVO3b.html" rel="bookmark" class="title">ajax-关于Ajax 入门一直出错</a>
					<div>
						问题描述 关于Ajax 入门一直出错 在客户端页面输入自己的名字,服务端返回'你好+名字'执行会有错误提示AjaxGet()函数未定义我是在VS下开发的给你们贴出目录和源码 HTMLPage.htm是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5RxBz.html" rel="bookmark" class="title">简单SOA框架实现</a>
					<div>
						14.4. Service-oriented architecture (SOA) SOA 与 REST很多相同之处,目前SOA主要是基于SOAP实现,也有基于MQ的实现.而REST只限于HTTP P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgENZz.html" rel="bookmark" class="title">【转载】Linux下tar&period;xz格式文件的解压方法</a>
					<div>
						     现在很多找到的 .tar.xz 格式的,xz 是一个使用 LZMA 压缩算法的无损数据压缩文件格式. 和 gzip 与 bzip2 一样支持多文件压缩,但是约定不能将多于一个的目标文件压缩进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM991KM.html" rel="bookmark" class="title">Flash中人物180&deg;转身动作实现</a>
					<div>
						前言:在傲旗的第二届flash大赛中,我提交了个作品,因为当时事儿多,所以没有最后完成,只做到了一半,其中的男主人公有个180°的转身动作,那个flash传上去以后,我记得香港的闪友&quot;李蠢& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN5a4b.html" rel="bookmark" class="title">贴吧也封我，百度又给站长当头一棒！</a>
					<div>
						百度|站长  每天到百度贴吧去发AD可能成了不少站长的习惯了,姜老师也是,刚在站长网写完文章(因为我给自己定下一个目标,每天要在站长网发布一个自己原创的文章,把自己建站的感想和体会和大家一起分享,同乐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrnjvM.html" rel="bookmark" class="title">处理驱动器和文件夹</a>
					<div>
						驱动器 使用 FileSystemObject (FSO) 对象模式,可以有计划地处理驱动器和文件夹,就像在 Windows 资源管理器中交互式地处理它们一样.可以复制和移动文件夹,获取有关驱动器和文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4nmqM.html" rel="bookmark" class="title">《&period;net编程先锋C&num;》第二章 理论基础－公用语言 运行环境（转）</a>
					<div>
						编程 第二章 理论基础-公用语言 运行环境既然你已经具有了C#全面的印象,我也想让你了解NGWS runtime的全貌.C#依靠由NGWS提供的运行时:因此,有必要知道运行时如何工作,以及它背后所蕴含 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLO7A8M.html" rel="bookmark" class="title">Vista系统22类问题解决方法</a>
					<div>
						1.如何关闭UAC? 控制面板→用户帐户→打开或关闭用户帐户控制→取消使用用户帐户控制(UAC)帮助保护您的计算机. 2.如何关闭系统备份与还原? 控制面板→备份和还原中心→创建还原点或更该设置→系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrvJdp.html" rel="bookmark" class="title">一个原创的仪表控件</a>
					<div>
						路过世纪飞扬的网站发现好些个仪表控件,可惜都要付费,这对于很多用户来说不得不说是一件憾事.最近两天导师项目不忙,就抽空做了一个仪表控件,是对照别人的仪表外观做的,在此公布出来大家讨论讨论,最好大家都写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4aw0p.html" rel="bookmark" class="title">Word入门动画教程109：字符间距和文字效果</a>
					<div>
						一.设置字符间距 1.选中要进行设置的文本. 2.执行&quot;格式&quot;→&quot;字体&quot;→&quot;字符间距&quot;选项卡. 3.&quot;字符间距&quot;选项卡主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKjwrp.html" rel="bookmark" class="title">C&num; 之不安全代码&lpar;2&rpar;</a>
					<div>
						固定的和活动的变量 &amp;和fixed将变量分为两类:固定的和活动的. 固定的变量永久的存在并不会被GC的操作影响.(例如局部变量,值参数和间接指针)活动的变量会被GC重新分配位置或是释放(例如对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2DaOb.html" rel="bookmark" class="title">Word2007文档框怎么制作</a>
					<div>
						  Word2007文档框怎么制作          第一步:新建一个Word2007文档,在菜单栏中找到插入选项,然后在其相应的工具栏中点文本框,在文档框的选项中,我们可以只选最简单的文本框,下来再 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPkQ0M.html" rel="bookmark" class="title">Excel里面灵活运用右键拖移完成非常快的拷贝</a>
					<div>
						在Excel工作表中,我们经常会将一个单元格或区域中的数据复制到另一位置.实现复制Excel表格数据的方法有许多种,最基本的是采用&quot;编辑&quot;菜单或鼠标右键中的复制/粘贴命令,或者使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ707Db.html" rel="bookmark" class="title">Linux系统如何安装及配置ClusterShell工具以便了解负载情况</a>
					<div>
						  Linux系统下如果你想了解多台数据库服务器之间的负载情况,那么你就会用到ClusterShell工具,作为Linux运维利器,其安装及配置也是一门学问,那么在Linux上要如何安装及配置Clus ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa378M.html" rel="bookmark" class="title">每次打开IE都出现欢迎使用的画面怎么办？</a>
					<div>
						  每次打开IE8都出现欢迎使用的画面,下一步完成设置之后,在此重新打开IE,依旧次现象,重置IE无效,卸载IE重新安装也无效,如下图 解决方案: 1.点击右下角开始菜单,在搜索程序和文件里面输入gp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGnZrp.html" rel="bookmark" class="title">电脑安装穿越火线CF提示不能打开要写入的文件怎么解决</a>
					<div>
						  电脑安装穿越火线CF提示不能打开要写入的文件怎么解决          1.出现这种情况可能是游戏启动时或者程序在下载过程被其他原因损坏,最好是关掉杀毒软件,再下载一次重新安装; 2.也可以试试换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaJBkM.html" rel="bookmark" class="title">纯文本和背景图式欢迎页面</a>
					<div>
						  文字与背景图片是每个现代网站都具有的重要元素,这两项首先映入用户眼帘,使他们熟悉网站标志.简介和导航.搭配合适的照片或图画,创造所需氛围. 文字与图片在网站的视觉和内容方面同时发挥作用,它们的组合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW6P0b.html" rel="bookmark" class="title">win7系统gpedit&period;msc进行解析时遇到错误的解决方法</a>
					<div>
						  很多注重win7系统安全的用户都会通过Gpedit.msc进入策略组开启修改相应的配置,不过近期有部分用户在使用gpedit.msc开启策略组时出现&quot;进行解析时遇到错误&quot;的错误 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmyPNz.html" rel="bookmark" class="title">Synchronized相关</a>
					<div>
						synchronized的说明 一.当两个并发线程访问同一个对象object中的这个synchronized(this)同步代码块时,一个时间内只能有一个线程得到执行.另一个线程必须等待当前线程执行完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk6DJb.html" rel="bookmark" class="title">linux-javac为什么不能编译子文件夹的java文件</a>
					<div>
						问题描述 javac为什么不能编译子文件夹的java文件 我在linux终端下编译:javac *.java 网上说这样做不是能编译当前文件夹下面所有的,包括子文件夹里面的java文件吗? 但是为什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32m6kz.html" rel="bookmark" class="title">Android用户界面设计：表格布局</a>
					<div>
						表格布局图可以用来显示表格式数据或者像网页上的HTML表格一样制作排列整齐的界面.本教程讲述如何分别运用XML布局文件和通过代码来创建表格布局. 理解布局对于良好的Android程序设计来说是非常重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NW5YM.html" rel="bookmark" class="title">编程c语言-大家帮帮忙，这个这个程序出黑框了，但是运行结果不正确</a>
					<div>
						问题描述 大家帮帮忙,这个这个程序出黑框了,但是运行结果不正确 大家帮帮忙,这个这个程序出黑框了,但是运行结果不正确,我的程序里男生女生分开了,但是它运行的结果男生女生并没有分开运算! 解决方案 if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwvBjM.html" rel="bookmark" class="title">android-分时将GPS数据写入到文件中</a>
					<div>
						问题描述 分时将GPS数据写入到文件中 private void writeToFile(String data) { try { OutputStreamWriter outputStreamWri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZJx4b.html" rel="bookmark" class="title">阿里云荣誉榜，聆听四大功能双管齐下</a>
					<div>
						双11临近,各大电商平台紧锣密鼓的筹备&quot;战事&quot;,消费者更是提早开始搜罗各大平台的优惠产品及优惠力度. 而阿里云有这么个产品不但免费使用,还送礼品,同时提供有逼格的炫耀姿势,秀出您的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRkr5b.html" rel="bookmark" class="title">PHP文件下载类&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: &lt;?    //====================================================    //   使用范例:    // $down ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnjByM.html" rel="bookmark" class="title">Laravel使用Caching缓存数据减轻数据库查询压力的方法&lowbar;php实例</a>
					<div>
						本文实例讲述了Laravel使用Caching缓存数据减轻数据库查询压力的方法.分享给大家供大家参考,具体如下: 昨天想把自己博客的首页做一下缓存,达到类似于生成静态页缓存的效果,在群里问了大家怎么做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkOjrM.html" rel="bookmark" class="title">教你如何判断关键词的竞争强度</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 站长在建成网站后都和我一样想知道怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0jWQM.html" rel="bookmark" class="title">【高德地图API】如何制作自己的旅游地图？</a>
					<div>
						原文:[高德地图API]如何制作自己的旅游地图? &quot;旅行的梦想并不遥远,只要一颗流浪四方的心.&quot;--唐人立. 最早认识唐人立的时候,他还是大二的学生.他独自完成了&quot;南京2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJGv8p.html" rel="bookmark" class="title">MySQL必知必会</a>
					<div>
						本文链接 http://alex-my.xyz/books/database/MySQL必知必会 http://blog.csdn.net/alex_my/article/details/723574 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60WVyz.html" rel="bookmark" class="title">东阿阿胶CIO沈渴望：BPM与企业战略集成</a>
					<div>
						我们1985年实施计算机管理.1989年http://www.aliyun.com/zixun/aggregation/11991.html&quot;&gt;计算机网络.2000年实施ERP,被评为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
